#ifndef __FIRMWAREKIT_H_INCLUDE_GUARD__
#define __FIRMWAREKIT_H_INCLUDE_GUARD__
/* 
 * Copyright (C) 2006, Intel Corporation
 * 
 * This file is part of the Linux-ready Firmware Developer Kit
 *
 * This program file is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by the
 * Free Software Foundation;version 2.1 of the License.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program in a file named COPYING; if not, write to the 
 * Free Software Foundation, Inc., 
 * 51 Franklin Street, Fifth Floor, 
 * Boston, MA 02110-1301 USA
 */


#include <stdint.h>
#include <glib.h>


#define	PASS	0
#define INFO	1

#define	WARN	2
#define	FAIL	4

#define MAX_SSDTS 11			/* Max # of DSDT and SSDT tables */
extern GList *boot_dmesg;
extern GList *ssdt[];
#define DMESG_FILE "/tmp/boot_dmesg"
#define DMESG_LOCAL_FILE "/var/log/dmesg"

/* libstandalone.c */

extern void start_test(char *testID, char *name, char *description);
extern void report_result(char *testID, int result, char *summary, char *details, char *devuri);
extern void finish_test(char *testID);
extern void report_testrun_progress(int percentage);
extern void announce_resource(char *uri, char *description, char *parent);

/* lib.c */

extern void chop_newline(char *s);
extern char *scatprintf(char *buffer, const char *fmt, ...);
extern void chop_lastchar(char *s);
extern int is_prefix(char *needle, char *haystack);
extern char *xmlescape(char *string);
extern int space_count(char *s);
extern void AML_to_uri(char *aml, char *uri);
extern char *get_time_stamp(void);
extern char *result_to_ascii(int res);

#endif

