/* 
 * Copyright (C) 2006, Intel Corporation
 * 
 * This file is part of the Linux-ready Firmware Developer Kit
 *
 * This program file is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by the
 * Free Software Foundation;version 2.1 of the License.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program in a file named COPYING; if not, write to the 
 * Free Software Foundation, Inc., 
 * 51 Franklin Street, Fifth Floor, 
 * Boston, MA 02110-1301 USA
 */

#define _GNU_SOURCE
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>
#include <stdarg.h>
#include <unistd.h>

#include <sys/types.h>
#include <dirent.h>

#include <glib.h>

#include "biostest.h"

void save_on_usb(void)
{
	DIR *dir;
	struct dirent *entry;
	FILE *file;
	int devcount = 0;
	char *c;

	dir = opendir("/sys/block");
	if (!dir) 
		return;
	do {
		char path[4096];
		char buffer[4096];
		entry = readdir(dir);

		if (!entry)
			break;

		if (entry->d_name[0]!='s') 
			continue;
		if (entry->d_name[1]!='d') 
			continue;

		sprintf(path,"/sys/block/%s/removable", entry->d_name);
		file = fopen(path, "r");
		if (!file)
			continue;
		fgets(path, 4095, file);
		fclose(file);
		/* usb disks are removable */
		if (path[0]!='1')
			continue;
		
		sprintf(path,"/sys/block/%s/device", entry->d_name);
		memset(buffer, 0, 4096);
		readlink(path, buffer, 4096);
		if (strstr(buffer, "usb")==NULL)
			continue;
		
		/* ok so we have a removable device with USB in the device string. Assume it's an USB key */
		sprintf(buffer, "/bin/mount /dev/%s1 /var/log/firmwarekit/usbkey &> /var/log/firmwarekit/mountlog", entry->d_name);
		if (system(buffer)!=0) {
			/* no cookie; maybe there was no partition table */
			sprintf(buffer, "/bin/mount /dev/%s /var/log/firmwarekit/usbkey &> mountlog", entry->d_name);
			if (system(buffer)!=0)
				continue;
		}
		system("/bin/cp /var/log/firmwarekit/* /var/log/firmwarekit/usbkey &> /dev/null");
		system("/bin/umount /var/log/firmwarekit/usbkey &> /dev/null");
		devcount ++;
	} while (entry);

	if (devcount) {
		c = "Test data successfully saved";
	} else {
		c = "No USB keys found; data not saved";
	}
	simple_ok_dialog("Save to USB", c);
	closedir(dir);
}
